/*
 * spriteCanvas.java
 *
 * Created on August 30, 2006, 1:48 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package runningHero;

import java.io.IOException;

import javax.microedition.lcdui.*;
import javax.microedition.lcdui.game.*;

public class spriteCanvas extends GameCanvas implements Runnable, CommandListener {
  /**Define some GAME constants*/
  private static final int kStanding = 1;
  private static final int kRunning = 2;

  private static final int kLeft = 1;
  private static final int kRight = 2;

  private static final int[] kRunningSequence = { 0, 1, 2 };
  private static final int[] kStandingSequence = { 3 };

  private boolean mFlag;

  /**Create Sprite, State and Direction*/
  private Sprite mSprite;
  private int mState, mDirection;

  /**Craere TiledLayer for Backgroung */
  private TiledLayer mBackground;

  /** Animated tiles */
  private int mAnimatedIndex;

  /** Create layer manager */
  private LayerManager lm;



/**Construct the displayable*/
  public spriteCanvas(){
    super(true);
    lm = new LayerManager();
    lm.setViewWindow(0,0,384,192);

    createSprite();
    createBackground();

    mFlag = true;
    Thread t = new Thread(this);
    t.start();
  }

  private void createBackground(){
    //Create Background
    Image bkImage = null;
    try{
      bkImage = Image.createImage("/runningHero/background.png");
    }catch(IOException e) {}
    int[][] map = {     //Two-D Array showiing the
        {1,2,0,0,0,0,0,0},
        {3,3,2,0,0,0,5,0},
        {3,3,3,2,4,1,3,2},
        {6,6,6,6,6,6,6,6}
    };
    mBackground = new TiledLayer(8,4,bkImage,48,48);

    for (int i=0; i<4; i++)   //ROWS
      for (int j=0; j<8; j++)   //COLUMNS
        mBackground.setCell(j, i, map[i][j]);

    mAnimatedIndex = mBackground.createAnimatedTile(8);
    mBackground.setCell(3,0,mAnimatedIndex);
    mBackground.setCell(5,0,mAnimatedIndex);



    lm.append(mBackground);


  }

  private void createSprite(){
    // Create the sprite.
    Image spriteImage = null;
    try{
     spriteImage = Image.createImage("/runningHero/move.png");
    }catch(IOException e) {}
    mSprite = new Sprite(spriteImage, 48, 48);
    mSprite.setPosition(getWidth()/2,getHeight()/2+12);
    mSprite.defineReferencePixel(24, 24);
    setDirection(kLeft);
    setState(kStanding);
    lm.append(mSprite);
  }

  private void setDirection(int newDirection) {
      if (newDirection == mDirection) return;
      if (mDirection == kLeft)
        mSprite.setTransform(Sprite.TRANS_MIRROR);
      else if (mDirection == kRight)
        mSprite.setTransform(Sprite.TRANS_NONE);
      mDirection = newDirection;
    }

    private void setState(int newState) {
      if (newState == mState) return;
      switch (newState) {
        case kStanding:
          mSprite.setFrameSequence(kStandingSequence);
          mSprite.setFrame(0);
          break;
        case kRunning:
          mSprite.setFrameSequence(kRunningSequence);
          break;
        default:
          break;
      }
      mState = newState;
    }


    public void run() {
    int w = getWidth();
    int h = getHeight();
    Graphics g = getGraphics();
    int aniTiles = 8;

    while (mFlag) {

        int keyStates = getKeyStates();
        if ((keyStates & LEFT_PRESSED) != 0) {
          setDirection(kLeft);
          setState(kRunning);
          mBackground.move(3,0);
          mSprite.nextFrame();
        }
        else if ((keyStates & RIGHT_PRESSED) != 0) {
          setDirection(kRight);
          setState(kRunning);
          mBackground.move(-3,0);
          mSprite.nextFrame();
        }
        else {
          setState(kStanding);
        }

        mBackground.setAnimatedTile(mAnimatedIndex,aniTiles++);
        if (aniTiles > 10) aniTiles = 8;

        //clear the screen
        g.setColor(255,255,255);
        g.fillRect(0, 0, w, h);

        lm.paint(g,0,0); //paint the layer manager
        flushGraphics();

      try { Thread.sleep(80); }
      catch (InterruptedException ie) {}
    }
  }



  /**Handle command events*/
  public void commandAction(Command command, Displayable displayable) {
    /** @todo Add command handling code */
    if (command.getCommandType() == Command.EXIT) {
// stop the MIDlet
      spriteMIDlet.quitApp();
    }
  }


}
