/*
 * flightGameV3Canvas.java
 *
 * Created on August 30, 2006, 1:39 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package flightGameV3;

/**
 *
 * @author dcsab
 */
import javax.microedition.lcdui.*;
import javax.microedition.lcdui.game.*;
import java.io.IOException;
import java.util.Random;

public class flightGameV3Canvas extends GameCanvas implements CommandListener, Runnable {
  Sprite mFlight, mBalloon1, mBalloon2, mExplosive;
  private static int LEFT = 1;
  private static int RIGHT = 2;
  /**Construct the displayable*/
  public flightGameV3Canvas() {
    super(true);
    try {
      jbInit();
      createFlight();  //call create flight para or method to create Flight
      createBalloon(); //call create baloon para or method
      createExplosive(); //call create explosive para or method



      Thread t = new Thread(this);
      t.start();



    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  private void createFlight(){
    //create the sprite
    Image flightImage = null;
    try{
      flightImage = Image.createImage("/flightGameV3/mustang.png");
      } catch(IOException e){}
      mFlight = new Sprite(flightImage, 36,18);
      mFlight.setPosition(getWidth()/2, getHeight()/2);
      mFlight.defineReferencePixel(18,9);
  }

  private void createBalloon(){
  // Create the sprite.
  Image balloonImage = null;
  try{
   balloonImage = Image.createImage("/flightGameV3/hotair.png");
  }catch(IOException e) {}
  mBalloon1 = new Sprite(balloonImage, 18, 18);
  mBalloon1.setPosition(10,0);

  mBalloon2 = new Sprite(balloonImage, 18, 18);
  mBalloon2.setPosition(40,0);

}

private void createExplosive(){
  // Create the sprite.
  Image explosiveImage = null;
  try{
   explosiveImage = Image.createImage("/flightGameV3/explosive.png");
  }catch(IOException e) {}
  mExplosive = new Sprite(explosiveImage, 36, 50);

}




  private void setDirection(int direc)
  {
    if (direc == LEFT){
      mFlight.setTransform(Sprite.TRANS_MIRROR);
    } else if (direc == RIGHT){
      mFlight.setTransform(Sprite.TRANS_NONE);
    }
  }

  //Implementing RUN method - (GAME LOOP) **/
   public void run(){
     Graphics g=getGraphics();

     boolean mFlag=true;
     Random rnd = new Random();
     int x;
     int tmCount = 0; //set initial time to ZERO

     while(mFlag){
       //tm=System.currentTimeMillis();

       int keyStates = getKeyStates();
       if ((keyStates & LEFT_PRESSED) !=0 ){
         setDirection(LEFT);
         mFlight.move(-3,0);
       }
       else if ((keyStates & RIGHT_PRESSED) !=0 ){
         setDirection(RIGHT);
         mFlight.move(3,0);
       }
       mBalloon1.move(0,7);
       mBalloon2.move(0,3);

       if (mBalloon1.getY()>getHeight()){  //Balloon1 hits bootom of screen
         x = Math.abs(   rnd.nextInt() % getWidth() );
         mBalloon1.setPosition(x,0);
       }
       if (mBalloon2.getY()>getHeight()){  //Balloon2 hits bootom of screen
         x = Math.abs(   rnd.nextInt() % getWidth() );
         mBalloon2.setPosition(x,0);
       }

       g.setColor(0,225,225) ;   // SET color to blue
       g.fillRect(0,0,getWidth(),getHeight()); //Clear sprite in the previous screen
       mFlight.paint(g); //draw flight in new position
       mBalloon1.paint(g);
       mBalloon2.paint(g);

       g.setColor(255,0,0);   //(R,G,B)   SET color to red
       g.drawString("Score: " +Integer.toString(tmCount),0,getHeight()-20,0); //draw TIME

       if (mFlight.collidesWith(mBalloon1,false) || mFlight.collidesWith(mBalloon2,false)) {
         //Explosion
         mExplosive.setPosition(mFlight.getX(),mFlight.getY());
         mExplosive.paint(g);
         g.setColor(255,0,0);   //(R,G,B)
         g.drawString("GAME IS OVER",0,0,0);   //anchor POINT IS 0
         flushGraphics();
         break;    //come-out of while LOOP


       }



       flushGraphics();

       try {Thread.sleep(80);}
       catch (InterruptedException ie){}
       tmCount = tmCount + 1;
     }
    }




  /**Component initialization*/
  private void jbInit() throws Exception {
    // set up this Displayable to listen to command events
    setCommandListener(this);
    // add the Exit command
    addCommand(new Command("Exit", Command.EXIT, 1));
    addCommand(new Command("Re-Start", Command.OK , 1));
  }

  /**Handle command events*/
  public void commandAction(Command command, Displayable displayable) {
    /** @todo Add command handling code */
    if (command.getCommandType() == Command.EXIT) {
      flightGameV3Midlet.quitApp();
    }
    if (command.getCommandType() == Command.OK) {
     // re-start the game
     mBalloon1.setPosition(10,0);  //initialise the balloon positions
     mBalloon2.setPosition(40,0);
     Thread t = new Thread(this);  //re-start the game in new thread
     t.start();

   }

  }



}
